%define _duplicate_files_terminate_build 0

%define major 1
%define minor  6

%define libname_a %mklibname sfml-audio %{major}.%{minor}
%define devname_a %mklibname sfml-audio -d
%define libname_g %mklibname sfml-graphics %{major}.%{minor}
%define devname_g %mklibname sfml-graphics -d
%define libname_n %mklibname sfml-network %{major}.%{minor}
%define devname_n %mklibname sfml-network -d
%define libname_s %mklibname sfml-system %{major}.%{minor}
%define devname_s %mklibname sfml-system -d
%define libname_w %mklibname sfml-window %{major}.%{minor}
%define devname_w %mklibname sfml-window -d

%define cname c%{name}

%define libname_ac %mklibname csfml-audio %{major}.%{minor}
%define devname_ac %mklibname csfml-audio -d
%define libname_gc %mklibname csfml-graphics %{major}.%{minor}
%define devname_gc %mklibname csfml-graphics -d
%define libname_nc %mklibname csfml-network %{major}.%{minor}
%define devname_nc %mklibname csfml-network -d
%define libname_sc %mklibname csfml-system %{major}.%{minor}
%define devname_sc %mklibname csfml-system -d
%define libname_wc %mklibname csfml-window %{major}.%{minor}
%define devname_wc %mklibname csfml-window -d


Summary:	Simple and Fast Multimedia Library
Name:		sfml
Version:	1.6
Release:	12
License:	zlib/libpng License
Group:		System/Libraries
Url:		http://sourceforge.net/projects/sfml
Source0:	http://sourceforge.net/projects/sfml/files/sfml/%{version}/SFML-%{version}-sdk-linux-32.tar.gz
Source1:	http://sourceforge.net/projects/sfml/files/sfml/%{version}/SFML-%{version}-c-sdk-linux-32.tar.gz
Source10:	%{name}.rpmlintrc
# real links:
# wget http://sourceforge.net/projects/sfml/files/sfml/%{version}/SFML-%{version}-sdk-linux-32.tar.gz/download
# wget http://sourceforge.net/projects/sfml/files/sfml/%{version}/SFML-%{version}-c-sdk-linux-32.tar.gz/download
Patch0:		samples-qt-Makefile-qt-inc-path.patch
Patch1:		sfml-c-makefile.patch
Patch2:		rem-included-libs.patch
Patch3:		SFML-1.6-png15.patch
Patch4:		SFML-1.6-gcc4.7.patch
Patch5:		SFML-1.6-dso.patch
Patch6:		SFML-1.6-gcc4.9.patch
BuildRequires:	recode
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(openal)
BuildRequires:	pkgconfig(sndfile)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xrandr)
#for samples
BuildRequires:	qt4-devel
BuildRequires:	wxgtku-devel

%description
SFML is a portable and easy to use multimedia API written in C++.

Its features are :
 - portability,
 - object-oriented design,
 - flexibility (a lot of small packages),
 - easy to use,
 - easy to integrate with GUI toolkits.

The library is divided in 5 small packages :
 - audio
 - graphics
 - network
 - system
 - window

This package contains documentation and samples.

%files
%defattr(0644,root,root,0755)
%doc *.txt doc/*
%attr(0755,root,root) %{_bindir}/sfml-sample-*
%{_datadir}/%{name}/samples

########################################################
# C++ libs

%package -n %{devname_a}
Summary:	Header files from %{name}-audio
Group:		Development/C++
Requires:	sfml-system-devel = %{EVRD}
Requires:	%{libname_a} = %{EVRD}
Provides:	%{name}-audio-devel = %{EVRD}
Conflicts:	%{devname_ac}

%description -n %{devname_a}
Includes files for developing programs based on %{name}-audio.

%files -n %{devname_a}
%defattr(0644,root,root,0755)
%{_includedir}/SFML/Audio.hpp
%{_includedir}/SFML/Audio
%{_libdir}/libsfml-audio.so

#----------------------------------------------------------------------------

%package -n %{devname_g}
Summary:	Header files from %{name}-graphics
Group:		Development/C++
Requires:	sfml-window-devel = %{EVRD}
Requires:	%{libname_g} = %{EVRD}
Provides:	%{name}-graphics-devel = %{EVRD}
Conflicts:	%{devname_gc}

%description -n %{devname_g}
Includes files for developing programs based on %{name}-graphics.

%files -n %{devname_g}
%defattr(0644,root,root,0755)
%{_includedir}/SFML/Graphics.hpp
%{_includedir}/SFML/Graphics
%{_libdir}/libsfml-graphics.so

#----------------------------------------------------------------------------

%package -n %{devname_n}
Summary:	Header files from %{name}-network
Group:		Development/C++
Requires:	sfml-system-devel = %{EVRD}
Requires:	%{libname_n} = %{EVRD}
Provides:	%{name}-network-devel = %{EVRD}
Conflicts:	%{devname_nc}

%description -n %{devname_n}
Includes files for developing programs based on %{name}-network.

%files -n %{devname_n}
%defattr(0644,root,root,0755)
%{_includedir}/SFML/Network.hpp
%{_includedir}/SFML/Network
%{_libdir}/libsfml-network.so

#----------------------------------------------------------------------------

%package -n %{devname_s}
Summary:	Header files from %{name}-system
Group:		Development/C++
Requires:	%{libname_s} = %{EVRD}
Provides:	%{name}-system-devel = %{EVRD}
Conflicts:	%{devname_sc}

%description -n %{devname_s}
Includes files for developing programs based on %{name}-system.

%files -n %{devname_s}
%defattr(0644,root,root,0755)
%dir %{_includedir}/SFML
%{_includedir}/SFML/Config.hpp
%{_includedir}/SFML/System.hpp
%{_includedir}/SFML/System
%{_libdir}/libsfml-system.so

#----------------------------------------------------------------------------

%package -n %{devname_w}
Summary:	Header files from %{name}-window
Group:		Development/C++
Requires:	sfml-system-devel = %{EVRD}
Requires:	%{libname_w} = %{EVRD}
Provides:	%{name}-window-devel = %{EVRD}
Conflicts:	%{devname_wc}

%description -n %{devname_w}
Includes files for developing programs based on %{name}-window.

%files -n %{devname_w}
%defattr(0644,root,root,0755)
%{_includedir}/SFML/Window.hpp
%{_includedir}/SFML/Window
%{_libdir}/libsfml-window.so

#----------------------------------------------------------------------------

%package -n %{libname_a}
Summary:	Dynamic libraries from %{name}-audio
Group:		System/Libraries
Provides:	%{name}-audio = %{EVRD}

%description -n %{libname_a}
Dynamic libraries from %{name}-audio.

%files -n %{libname_a}
%{_libdir}/libsfml-audio.so.%{major}.%{minor}

#----------------------------------------------------------------------------

%package -n %{libname_g}
Summary:	Dynamic libraries from %{name}-graphics
Group:		System/Libraries
Provides:	%{name}-graphics = %{EVRD}

%description -n %{libname_g}
Dynamic libraries from %{name}-graphics.

%files -n %{libname_g}
%{_libdir}/libsfml-graphics.so.%{major}.%{minor}

#----------------------------------------------------------------------------

%package -n %{libname_n}
Summary:	Dynamic libraries from %{name}-network
Group:		System/Libraries
Provides:	%{name}-network = %{EVRD}

%description -n %{libname_n}
Dynamic libraries from %{name}-network.

%files -n %{libname_n}
%{_libdir}/libsfml-network.so.%{major}.%{minor}

#----------------------------------------------------------------------------

%package -n %{libname_s}
Summary:	Dynamic libraries from %{name}-system
Group:		System/Libraries
Provides:	%{name}-system = %{EVRD}

%description -n %{libname_s}
Dynamic libraries from %{name}-system.

%files -n %{libname_s}
%{_libdir}/libsfml-system.so.%{major}.%{minor}

#----------------------------------------------------------------------------

%package -n %{libname_w}
Summary:	Dynamic libraries from %{name}-window
Group:		System/Libraries
Provides:	%{name}-window = %{EVRD}

%description -n %{libname_w}
Dynamic libraries from %{name}-window.

%files -n %{libname_w}
%{_libdir}/libsfml-window.so.%{major}.%{minor}

########################################################
# C libs

%package -n %{devname_ac}
Summary:	Header files from %{cname}-audio
Group:		Development/C
Requires:	sfml-system-devel = %{EVRD}
Requires:	%{libname_ac} = %{EVRD}
Requires:	%{libname_a} = %{EVRD}
Provides:	%{cname}-audio-devel = %{EVRD}

%description -n %{devname_ac}
Includes files for developing programs based on %{cname}-audio.

%files -n %{devname_ac}
%defattr(0644,root,root,0755)
%{_includedir}/SFML/Audio.h
%{_includedir}/SFML/Audio
%{_libdir}/libcsfml-audio.so

#----------------------------------------------------------------------------

%package -n %{devname_gc}
Summary:	Header files from %{cname}-graphics
Group:		Development/C
Requires:	sfml-window-devel = %{EVRD}
Requires:	%{libname_gc} = %{EVRD}
Requires:	%{libname_g} = %{EVRD}
Provides:	%{cname}-graphics-devel = %{EVRD}

%description -n %{devname_gc}
Includes files for developing programs based on %{cname}-graphics.

%files -n %{devname_gc}
%defattr(0644,root,root,0755)
%{_includedir}/SFML/Graphics.h
%{_includedir}/SFML/Graphics
%{_libdir}/libcsfml-graphics.so

#----------------------------------------------------------------------------

%package -n %{devname_nc}
Summary:	Header files from %{cname}-network
Group:		Development/C
Requires:	sfml-system-devel = %{EVRD}
Requires:	%{libname_nc} = %{EVRD}
Requires:	%{libname_n} = %{EVRD}
Provides:	%{cname}-network-devel = %{EVRD}

%description -n %{devname_nc}
Includes files for developing programs based on %{cname}-network.

%files -n %{devname_nc}
%defattr(0644,root,root,0755)
%{_includedir}/SFML/Network.h
%{_includedir}/SFML/Network
%{_libdir}/libcsfml-network.so

#----------------------------------------------------------------------------

%package -n %{devname_sc}
Summary:	Header files from %{cname}-system
Group:		Development/C
Requires:	%{libname_sc} = %{EVRD}
Requires:	%{libname_s} = %{EVRD}
Provides:	%{cname}-system-devel = %{EVRD}

%description -n %{devname_sc}
Includes files for developing programs based on %{cname}-system.

%files -n %{devname_sc}
%defattr(0644,root,root,0755)
%dir %{_includedir}/SFML
%{_includedir}/SFML/Config.h
%{_includedir}/SFML/System.h
%{_includedir}/SFML/System
%{_libdir}/libcsfml-system.so

#----------------------------------------------------------------------------

%package -n %{devname_wc}
Summary:	Header files from %{cname}-window
Group:		Development/C
Requires:	sfml-system-devel = %{EVRD}
Requires:	%{libname_wc} = %{EVRD}
Requires:	%{libname_w} = %{EVRD}
Provides:	%{cname}-window-devel = %{EVRD}

%description -n %{devname_wc}
Includes files for developing programs based on %{cname}-window.

%files -n %{devname_wc}
%defattr(0644,root,root,0755)
%{_includedir}/SFML/Window.h
%{_includedir}/SFML/Window
%{_libdir}/libcsfml-window.so

#----------------------------------------------------------------------------

%package -n %{libname_ac}
Summary:	Dynamic libraries from %{cname}-audio
Group:		System/Libraries
Requires:	%{libname_a} = %{EVRD}
Provides:	%{cname}-audio = %{EVRD}

%description -n %{libname_ac}
Dynamic libraries from %{cname}-audio.

%files -n %{libname_ac}
%{_libdir}/libcsfml-audio.so.%{major}.%{minor}

#----------------------------------------------------------------------------

%package -n %{libname_gc}
Summary:	Dynamic libraries from %{cname}-graphics
Group:		System/Libraries
Requires:	%{libname_g} = %{EVRD}
Provides:	%{cname}-graphics = %{EVRD}

%description -n %{libname_gc}
Dynamic libraries from %{cname}-graphics.

%files -n %{libname_gc}
%{_libdir}/libcsfml-graphics.so.%{major}.%{minor}

#----------------------------------------------------------------------------

%package -n %{libname_nc}
Summary:	Dynamic libraries from %{cname}-network
Group:		System/Libraries
Requires:	%{libname_n} = %{EVRD}
Provides:	%{cname}-network = %{EVRD}

%description -n %{libname_nc}
Dynamic libraries from %{cname}-network.

%files -n %{libname_nc}
%{_libdir}/libcsfml-network.so.%{major}.%{minor}

#----------------------------------------------------------------------------

%package -n %{libname_sc}
Summary:	Dynamic libraries from %{cname}-system
Group:		System/Libraries
Requires:	%{libname_s} = %{EVRD}
Provides:	%{cname}-system = %{EVRD}

%description -n %{libname_sc}
Dynamic libraries from %{cname}-system.

%files -n %{libname_sc}
%{_libdir}/libcsfml-system.so.%{major}.%{minor}

#----------------------------------------------------------------------------

%package -n %{libname_wc}
Summary:	Dynamic libraries from %{cname}-window
Group:		System/Libraries
Requires:	%{libname_w} = %{EVRD}
Provides:	%{cname}-window = %{EVRD}

%description -n %{libname_wc}
Dynamic libraries from %{cname}-window.

%files -n %{libname_wc}
%{_libdir}/libcsfml-window.so.%{major}.%{minor}

########################################################

%prep
%setup -q -b1 -n SFML-%{version}
rm -f lib/*.so*
# removing included libs
rm -rf src/SFML/Graphics/libjpeg/
rm -rf src/SFML/Graphics/libpng/
rm -rf src/SFML/Graphics/zlib/
%patch0 -p0 -b .qtincpath
%patch1 -p0 -b .csfml
%patch2 -p1 -b .inclibs
%patch3 -p1 -b .png15
%patch4 -p1 -b .gcc46
%patch5 -p1 -b .dso
%patch6 -p1 -b .gcc49

%ifarch x86_64
perl -pi -e "s|DESTDIR\)/lib|DESTDIR\)/lib64|" src/SFML/Makefile
%endif
perl -pi -e "s|\r\n|\n|g" *.txt
recode l1..u8 *.txt

%ifarch x86_64
perl -pi -e "s|DESTDIR\)/lib|DESTDIR\)/lib64|" CSFML/src/SFML/Makefile
%endif

# fix samples build
perl -pi -e "s|export LDFLAGS  =|export LDFLAGS  = -L%{_libdir} -L../../lib|" \
 samples/Makefile
perl -pi -e "s|-I/usr/include/qt4|-I/usr/lib/qt4/include|" \
 samples/qt/Makefile

# fix samples data location
find samples -name "*.cpp" -exec perl -pi -e \
 "s|datas|%{_datadir}/%{name}/samples/bin/datas|g" {} +

%build
%make DEBUGFLAGS="%{optflags}"
#samples
pushd lib
for i in *.so* ; do ln -s $i ${i%.1.6} ; done
popd
pushd samples
%make
popd
pushd CSFML
%make DEBUGFLAGS="%{optflags}"
popd

%install
%makeinstall_std DESTDIR=%{buildroot}%{_prefix}

pushd CSFML
%makeinstall_std DESTDIR=%{buildroot}%{_prefix}
popd

# install sample source and data
rm -f %{buildroot}%{_datadir}/%{name}/samples/*/*.o
install -d -m 755 %{buildroot}%{_datadir}/%{name}/samples
cp -R ./samples/* %{buildroot}%{_datadir}/%{name}/samples/
rm -f %{buildroot}%{_datadir}/%{name}/samples/*/*.o

# install sample binaries to sfml-sample*
install -d -m 755 %{buildroot}%{_bindir}
for i in %{buildroot}%{_datadir}/%{name}/samples/bin/[!d]* ; do \
 mv $i %{buildroot}%{_bindir}/sfml-sample-`basename $i` ; done


%changelog

* Mon May 09 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.6-12
- (457468b) Build with system optflags
- (457468b) Filter out some rpmlint errors


